.386
.model flat,stdcall
option casemap:none

include windows.inc
include kernel32.inc
include user32.inc
include ws2_32.inc
include masm32.inc
include mpr.inc 

includelib kernel32.lib
includelib user32.lib
includelib ws2_32.lib
includelib masm32.lib
includelib mpr.lib

WinMain	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
ConnectDlgProc	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
NickDlgProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD

ShowData 	PROTO :DWORD
m2m MACRO p1,p2
	push p2
	pop p1
endm
.const
Menu_Connect	equ	5000
Menu_Exit		equ	5001
Menu_Listen		equ	5002
Menu_Nick		equ	5003
Menu_About		equ	5004

Ctrl_DataView	equ	2000
Ctrl_Message	equ	2001
Ctrl_Send		equ	2002
Dlg_Connect		equ	2003
Dlg_Nick		equ	2004

Ctrl_Comps		equ	1002
Ctrl_Label1		equ	1003
Ctrl_Label2		equ	1004
Ctrl_Address	equ	1006
Ctrl_Nick		equ	1009

WM_SOCKET		equ	WM_USER+100
.data
ALIGN DWORD
AppName		db	"Phoenix p2p Chat",0
ClassName	db	"PhoenixWindowClass",0
IconName	db	"AppIcon",0
MenuName	db	"PhoenixMenu",0
AboutName	db	"	This program was made by Thomas Antony.",13,10
			db	"This is not meant for commercial use and I",13,10
			db	"I will not be held responsible for any damage",13,10
			db	"caused to your computer or you due to using",13,10
			db	"this program.",13,10,13,10
			db	"By Thomas Antony",13,10
			db	"Website: http://www.tomasm.tk/",13,10
			db	"E-mail: webmaster@thomasantony.cjb.net",13,10,0
			

EditClass	db	"edit",0
StaticClass	db	"static",0
ButtonClass	db	"button",0

ConnLabel	db	"&Connect",0
SendLabel	db	"&Send",0

MenuDisConn	db	"Dis&connect",0
MenuListen	db	"&Wait for Call",0
MenuStop	db	"Stop waiting",0

Msg_Accept	db	"New incoming connection",13,10
			db	"Accept?",0
Msg_Conn	db	"Connecting to %s....",13,10,0
Msg_Connect	db	"Connected to %s!!",13,10,0
Msg_BadConn	db	"Connection closed to %s",13,10,0
Msg_NickOk	db	"Nickname set to %s",13,10,0

Msg_Listen	db	"Listening for connections on port 45454",13,10,0
Msg_In		db	"Incoming connection from %s!!",13,10,0
Msg_Format	db	"%s: %s",13,10,0

Err_MustConnect	db	"You must connect to someone before sending!!",13,10,0
Err_MustHost	db	"You must enter a hostname or select a host to connect!!",0
Err_MustNick	db	"you must enter a nickname to connect!!",0
Err_BadHost		db	"Cannot resolve host",0
Err_Connect		db	"Error connecting to %s",0

Connected	dd	FALSE
Connecting	dd	FALSE
Waiting		dd	FALSE
.data?
hInstance	HINSTANCE	?

hDataView	HANDLE		?
hMessage	HANDLE		?
hSend		HANDLE		?
hConnect	HANDLE		?
hMenu		HMENU		?
listenSock	SOCKET		?
sock		SOCKET		?
insock		SOCKET		?
hostAddr	DWORD		?
addrlen		DWORD		?

OutBuffer	db	600 dup(?)
MessageBuff	db	512 dup(?)
HostAddr	db	256 dup(?)
NickName	db	50 dup(?)

wsadata		WSADATA		<?>
sin			sockaddr_in	<?>
.code
ALIGN DWORD
start:
	invoke GetModuleHandle,0
	mov hInstance,eax
	invoke WSAStartup,202h,ADDR wsadata
	invoke WinMain,hInstance,0,0,SW_SHOW
	invoke WSACleanup
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov wc.cbSize,SIZEOF WNDCLASSEX
	mov wc.style,CS_VREDRAW+CS_HREDRAW
	mov wc.lpfnWndProc,OFFSET WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	m2m wc.hInstance,hInst
	invoke LoadIcon,hInst,ADDR IconName
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	mov wc.hbrBackground,COLOR_BACKGROUND+10
	mov wc.lpszMenuName,OFFSET MenuName
	mov wc.lpszClassName,OFFSET ClassName
	invoke RegisterClassEx,ADDR wc
	invoke CreateWindowEx,0,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,150,50,350,400,0,0,hInst,0
	mov hwnd,eax
	invoke ShowWindow,hwnd,SW_SHOW
	invoke UpdateWindow,hwnd
	.WHILE TRUE
		invoke GetMessage,ADDR msg,0,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg
	.ENDW
	mov eax,msg.wParam
	Ret
WinMain EndP
WndProc proc uses esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL hFileMenu:HMENU
LOCAL mbp:MSGBOXPARAMS
LOCAL temp:DWORD
	.IF uMsg==WM_INITMENUPOPUP
	mov eax,lParam
	and eax,0ffffh
	.if ax==0
		m2m hFileMenu,wParam
		.if Connecting
			invoke ModifyMenu,hFileMenu,Menu_Connect,MF_BYCOMMAND+MF_STRING,Menu_Connect,ADDR MenuDisConn
		.elseif !Connecting
			invoke ModifyMenu,hFileMenu,Menu_Connect,MF_BYCOMMAND+MF_STRING,Menu_Connect,ADDR ConnLabel
		.endif
		.if Waiting
			invoke ModifyMenu,hFileMenu,Menu_Listen,MF_BYCOMMAND+MF_STRING,Menu_Listen,ADDR MenuStop
		.else
			invoke ModifyMenu,hFileMenu,Menu_Listen,MF_BYCOMMAND+MF_STRING,Menu_Listen,ADDR MenuListen
		.endif
		.if Connecting
			invoke EnableMenuItem,hFileMenu,Menu_Listen,MF_GRAYED+MF_BYCOMMAND
		.elseif !Connecting
			invoke EnableMenuItem,hFileMenu,Menu_Listen,MF_ENABLED+MF_BYCOMMAND
		.endif
		.if Waiting
			invoke EnableMenuItem,hFileMenu,Menu_Connect,MF_GRAYED+MF_BYCOMMAND
		.elseif !Waiting
			invoke EnableMenuItem,hFileMenu,Menu_Connect,MF_ENABLED+MF_BYCOMMAND
		.endif
	.endif
	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.if ax==Menu_Exit
			invoke SendMessage,hWnd,WM_CLOSE,0,0
		.elseif ax==Menu_Connect
			.if !Connected
				invoke DialogBoxParam,hInstance,Dlg_Connect,hWnd,ADDR ConnectDlgProc,0
				.if !eax
					ret
				.endif
				invoke socket,PF_INET,SOCK_STREAM,0
				mov sock,eax

				mov eax,hostAddr
				mov sin.sin_addr,eax
				mov ax,45454
				xchg ah,al
				mov sin.sin_port,ax
				invoke connect,sock,ADDR sin,SIZEOF sin
				invoke WSAAsyncSelect,sock,hWnd,WM_SOCKET,FD_CONNECT+FD_READ+FD_CLOSE
				invoke wsprintf,ADDR OutBuffer,ADDR Msg_Conn,ADDR HostAddr
				invoke ShowData,ADDR OutBuffer
				mov Connecting,TRUE
				invoke SetWindowText,hConnect,ADDR MenuDisConn
			.else
				invoke closesocket,sock
				invoke wsprintf,ADDR OutBuffer,ADDR Msg_BadConn,ADDR HostAddr
				invoke ShowData,ADDR OutBuffer
				mov Connecting,FALSE
				invoke SetWindowText,hConnect,ADDR ConnLabel
			.endif
		.elseif ax==Menu_Listen
			.if !Waiting
				invoke socket,AF_INET,SOCK_STREAM,IPPROTO_IP
				mov listenSock,eax
				mov sin.sin_addr,INADDR_ANY
				mov ax,45454
				xchg ah,al
				mov sin.sin_port,ax
				invoke WSAAsyncSelect,listenSock,hWnd,WM_SOCKET,FD_ACCEPT+FD_READ+FD_CLOSE
				invoke bind,listenSock,ADDR sin,SIZEOF sin
				invoke listen,listenSock,1
				invoke ShowData,ADDR Msg_Listen
				mov Waiting,TRUE
				invoke SetWindowText,hConnect,ADDR MenuDisConn
			.else
				invoke closesocket,sock
				mov Waiting,FALSE
				invoke SetWindowText,hConnect,ADDR ConnLabel
			.endif
		.elseif ax==Menu_Nick
			invoke DialogBoxParam,hInstance,Dlg_Nick,hWnd,ADDR NickDlgProc,0
		.elseif ax==Menu_About
			invoke MessageBoxIndirect,ADDR mbp
		.elseif ax==Ctrl_Send
			.if !Connected
				invoke ShowData,ADDR Err_MustConnect
				ret
			.endif
			invoke GetWindowText,hMessage,ADDR MessageBuff,512
			.if !eax
				ret
			.endif
			invoke wsprintf,ADDR OutBuffer,ADDR Msg_Format,ADDR NickName,ADDR MessageBuff
			invoke send,sock,ADDR OutBuffer,eax,0
			invoke ShowData,ADDR OutBuffer
		.endif
	.ELSEIF uMsg==WM_SOCKET
		mov eax,lParam
		.if ax==FD_CONNECT
			shr eax,16
			.if ax==0
				invoke wsprintf,ADDR OutBuffer,ADDR Msg_Connect,ADDR HostAddr
				invoke ShowData,ADDR OutBuffer
				mov Connected,TRUE
			.else
				invoke wsprintf,ADDR OutBuffer,ADDR Err_Connect,ADDR HostAddr
				invoke ShowData,ADDR OutBuffer
				mov Connected,FALSE
				mov Connecting,FALSE
			.endif
		.elseif ax==FD_READ
			invoke memfill,ADDR OutBuffer,600,0
			invoke recv,sock,ADDR OutBuffer,600,0
			invoke ShowData,ADDR OutBuffer
		.elseif ax==FD_ACCEPT
			invoke accept,listenSock,ADDR sin,ADDR addrlen
			mov sock,eax
			invoke getpeername,eax,ADDR sin,ADDR addrlen
			invoke inet_ntoa,sin.sin_addr.S_un.S_addr
			invoke wsprintf,ADDR OutBuffer,ADDR Msg_In,eax
			invoke ShowData,ADDR OutBuffer
			mov Connected,TRUE
		.elseif ax==FD_CLOSE
			invoke getpeername,wParam,ADDR sin,ADDR addrlen
			invoke inet_ntoa,sin.sin_addr.S_un.S_addr
			invoke wsprintf,ADDR OutBuffer,ADDR Msg_BadConn,eax
			invoke ShowData,ADDR OutBuffer
			mov Connected,TRUE
			mov Connecting,FALSE
		.endif
	.ELSEIF uMsg==WM_CREATE
		invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR EditClass,0,WS_VISIBLE+WS_CHILD+WS_VSCROLL+ES_AUTOVSCROLL+ES_MULTILINE+ES_READONLY,10,0,325,200,hWnd,Ctrl_DataView,hInstance,0
		mov hDataView,eax
		invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR EditClass,0,WS_VISIBLE+WS_CHILD+ES_AUTOHSCROLL,10,230,325,20,hWnd,Ctrl_Message,hInstance,0
		mov hMessage,eax
		invoke SendMessage,eax,EM_SETLIMITTEXT,512,0
		
		invoke CreateWindowEx,0,ADDR ButtonClass,ADDR ConnLabel,WS_VISIBLE+WS_CHILD+BS_PUSHBUTTON,10,255,75,25,hWnd,Menu_Connect,hInstance,0
		mov hConnect,eax
		invoke CreateWindowEx,0,ADDR ButtonClass,ADDR SendLabel,WS_VISIBLE+WS_CHILD+BS_PUSHBUTTON,90,255,75,25,hWnd,Ctrl_Send,hInstance,0
		mov hSend,eax
		
		invoke GetMenu,hWnd
		mov hMenu,eax
		mov addrlen,SIZEOF sockaddr_in
		mov sin.sin_family,AF_INET
		mov temp,50
		invoke GetComputerName,ADDR NickName,ADDR temp
		
		mov mbp.cbSize,SIZEOF MSGBOXPARAMS
		m2m mbp.hwndOwner,hWnd
		m2m mbp.hInstance,hInstance
		mov mbp.lpszText,OFFSET AboutName
		mov mbp.lpszCaption,OFFSET AppName
		mov mbp.dwStyle,MB_USERICON+MB_OK
		mov mbp.lpszIcon,OFFSET IconName
	.ELSEIF uMsg==WM_DESTROY
		invoke PostQuitMessage,0
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor eax,eax
	ret
WndProc EndP
ConnectDlgProc proc hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	.IF uMsg==WM_COMMAND
		mov eax,wParam
		.if ax==IDCANCEL
			invoke SendMessage,hDlg,WM_CLOSE,0,0
		.elseif ax==IDOK
			invoke GetDlgItemText,hDlg,Ctrl_Address,ADDR HostAddr,256
			.if !eax
				invoke MessageBox,hDlg,ADDR Err_MustHost,ADDR AppName,MB_ICONEXCLAMATION+MB_OK
				ret
			.endif
			invoke inet_addr,ADDR HostAddr
			.if eax==INADDR_NONE
				invoke gethostbyname,ADDR HostAddr
				.if eax==0
					invoke MessageBox,hDlg,ADDR Err_BadHost,ADDR AppName,MB_ICONINFORMATION+MB_OK
					ret
				.endif
				mov eax,(hostent ptr [eax]).h_list
				mov eax,[eax]
				mov eax,[eax]
			.endif
			mov hostAddr,eax
			invoke EndDialog,hDlg,TRUE
		.endif
	.ELSEIF uMsg==WM_INITDIALOG
		invoke SetDlgItemText,hDlg,Ctrl_Nick,ADDR NickName
		invoke GetDlgItem,hDlg,Ctrl_Address
		invoke SetFocus,eax
		invoke SendDlgItemMessage,hDlg,Ctrl_Address,EM_SETLIMITTEXT,255,0
	.ELSEIF uMsg==WM_CLOSE
		invoke EndDialog,hDlg,FALSE
		ret
	.ELSE
		xor eax,eax
		ret
	.ENDIF
	mov eax,1
	Ret
ConnectDlgProc EndP
NickDlgProc proc hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	.IF uMsg==WM_INITDIALOG
		invoke SetDlgItemText,hDlg,Ctrl_Nick,ADDR NickName
		invoke SendDlgItemMessage,hDlg,Ctrl_Nick,EM_SETLIMITTEXT,30,0
	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.if ax==IDOK
			invoke GetDlgItemText,hDlg,Ctrl_Nick,ADDR NickName,50
			.if !eax
				invoke MessageBox,hDlg,ADDR Err_MustNick,ADDR AppName,MB_ICONEXCLAMATION+MB_OK
				ret
			.endif
			invoke wsprintf,ADDR OutBuffer,ADDR Msg_NickOk,ADDR NickName
			invoke ShowData,ADDR OutBuffer
			invoke EndDialog,hDlg,1
		.elseif ax==IDCANCEL
			invoke SendMessage,hDlg,WM_CLOSE,0,0
		.endif
	.ELSEIF uMsg==WM_CLOSE
		invoke EndDialog,hDlg,0
	.ELSE
		xor eax,eax
		ret
	.ENDIF
	mov eax,1
	Ret
NickDlgProc EndP
ShowData proc data:DWORD
	invoke SendMessage,hDataView,EM_SETSEL,-1,0
	invoke SendMessage,hDataView,EM_REPLACESEL,FALSE,data
	Ret
ShowData EndP
EnumNetwork proc 
LOCAL buff[10]:NETRESOURCE
LOCAL hEnum:HANDLE

	invoke WNetOpenEnum,RESOURCE_GLOBALNET,RESOURCETYPE_ANY,RESOURCEUSAGE_CONNECTABLE,0,ADDR hEnum
	
	Ret
EnumNetwork EndP
end start